diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java
index 982ac2a5b..6eefe9f74 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java
@@ -6,6 +6,7 @@ import net.minecraft.client.gui.keyboard.keys.Key;
 import net.minecraft.client.gui.text.ITextField;
 import net.minecraft.client.gui.text.TextFieldEditor;
 import net.minecraft.client.input.controller.ControllerInput;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
@@ -52,34 +53,34 @@ public class ScreenKeyboard extends Screen implements ITextField {
 
 
         this.keyboardLayout = KeyboardLayout.defaultLayout;
-        Arrays.stream(keyboardLayout.getKeys()).forEach(key -> key.onOpen(mc, this));
+        Arrays.stream(this.keyboardLayout.getKeys()).forEach(key -> key.onOpen(this.mc, this));
     }
 
     @Override
     public void opened(int width, int height) {
         Keyboard.enableRepeatEvents(true);
-        if (parent != null) {
-            parent.fontRenderer = mc.font;
-            parent.width = width;
-            parent.height = height;
+        if (this.parent != null) {
+            this.parent.fontRenderer = this.mc.font;
+            this.parent.width = width;
+            this.parent.height = height;
         }
-        this.glyphRenderer = new ControllerGlyphElement(mc);
+        this.glyphRenderer = new ControllerGlyphElement(this.mc);
         super.opened(width, height);
     }
 
     @Override
     public boolean isPauseScreen() {
-        if (parent != null) {
-            return parent.isPauseScreen();
+        if (this.parent != null) {
+            return this.parent.isPauseScreen();
         }
         return super.isPauseScreen();
     }
 
     @Override
     public void tick() {
-        cursorCounter++;
-        if (parent != null) {
-            parent.tick();
+        this.cursorCounter++;
+        if (this.parent != null) {
+            this.parent.tick();
         }
     }
 
@@ -93,12 +94,12 @@ public class ScreenKeyboard extends Screen implements ITextField {
     }
 
     public void typeChar(int key, char chr) {
-        if (editor.handleInput(key, chr)) {
-            if (keyAction != null) {
-                keyAction.apply(chr, key, editor.getText());
+        if (this.editor.handleInput(key, chr)) {
+            if (this.keyAction != null) {
+                this.keyAction.apply(chr, key, this.editor.getText());
             }
 
-            for (String id : activeModifiers.keySet()) {
+            for (String id : this.activeModifiers.keySet()) {
                 if (!isModifierLocked(id)) {
                     setModifierState(id, false);
                 }
@@ -107,50 +108,49 @@ public class ScreenKeyboard extends Screen implements ITextField {
     }
 
     public void backspace() {
-        editor.deleteCharsBeforeCursor(1);
-        if (backspaceAction != null) {
-            backspaceAction.apply(editor.getText());
+        this.editor.deleteCharsBeforeCursor(1);
+        if (this.backspaceAction != null) {
+            this.backspaceAction.apply(this.editor.getText());
         }
     }
 
     public void setModifierState(String id, boolean flag) {
-        activeModifiers.put(id, flag);
-        activeLocks.putIfAbsent(id, false);
+        this.activeModifiers.put(id, flag);
+        this.activeLocks.putIfAbsent(id, false);
     }
 
     public void setModifierLock(String id, boolean flag) {
-        activeModifiers.putIfAbsent(id, false);
-        activeLocks.put(id, flag);
+        this.activeModifiers.putIfAbsent(id, false);
+        this.activeLocks.put(id, flag);
     }
 
     public boolean isModifierActive(String id) {
-        return activeModifiers.getOrDefault(id, false) || isModifierLocked(id);
+        return this.activeModifiers.getOrDefault(id, false) || isModifierLocked(id);
     }
 
     public boolean isModifierLocked(String id) {
-        return activeLocks.getOrDefault(id, false);
+        return this.activeLocks.getOrDefault(id, false);
     }
 
     @Override
     public void removed() {
-        if (mc.controllerInput != null) {
-            mc.controllerInput.lockCursor = false;
-            mc.controllerInput.hideCursor = false;
+        if (this.mc.controllerInput != null) {
+            this.mc.controllerInput.lockCursor = false;
+            this.mc.controllerInput.hideCursor = false;
         }
-        if (resultStringAction != null) {
-            resultStringAction.apply(editor.getText());
+        if (this.resultStringAction != null) {
+            this.resultStringAction.apply(this.editor.getText());
         }
-        Keyboard.enableRepeatEvents(wasRepeating);
+        Keyboard.enableRepeatEvents(this.wasRepeating);
     }
 
-    public void close()
-    {
+    public void close() {
         this.removed();
-        mc.currentScreen = parent;
+        this.mc.currentScreen = this.parent;
     }
 
     public void setGroup(int group) {
-        group = MathHelper.clamp(group, 0, keyboardLayout.getHighestGroup());
+        group = MathHelper.clamp(group, 0, this.keyboardLayout.getHighestGroup());
         this.group = group;
     }
 
@@ -160,11 +160,11 @@ public class ScreenKeyboard extends Screen implements ITextField {
 
     public int getShiftedGroup(int amount) {
         int group = this.group + amount;
-        return (group + keyboardLayout.getHighestGroup() + 1) % (keyboardLayout.getHighestGroup() + 1);
+        return (group + this.keyboardLayout.getHighestGroup() + 1) % (this.keyboardLayout.getHighestGroup() + 1);
     }
 
     public int getGroup() {
-        return group;
+        return this.group;
     }
 
     @Override
@@ -173,45 +173,45 @@ public class ScreenKeyboard extends Screen implements ITextField {
             close();
             return;
         }
-        int _x = ((width - keyboardLayout.getWidth()) / 2);
-        int _y = height - keyboardLayout.getHeight() - 5;
-        Arrays.stream(keyboardLayout.getKeys()).forEach(key -> key.onClick(mc, this, _x, _y, mx, my, buttonNum));
+        int _x = ((this.width - this.keyboardLayout.getWidth()) / 2);
+        int _y = this.height - this.keyboardLayout.getHeight() - 5;
+        Arrays.stream(this.keyboardLayout.getKeys()).forEach(key -> key.onClick(this.mc, this, _x, _y, mx, my, buttonNum));
     }
 
     @Override
     public void mouseReleased(int mx, int my, int buttonNum) {
-        int _x = ((width - keyboardLayout.getWidth()) / 2);
-        int _y = height - keyboardLayout.getHeight() - 5;
-        Arrays.stream(keyboardLayout.getKeys()).forEach(key -> key.onRelease(mc, this, _x, _y, mx, my, buttonNum));
+        int _x = ((this.width - this.keyboardLayout.getWidth()) / 2);
+        int _y = this.height - this.keyboardLayout.getHeight() - 5;
+        Arrays.stream(this.keyboardLayout.getKeys()).forEach(key -> key.onRelease(this.mc, this, _x, _y, mx, my, buttonNum));
     }
 
     public boolean mouseOnKeyboard(int mx, int my) {
-        int keyboardWidth = keyboardLayout.getWidth();
-        int keyboardHeight = keyboardLayout.getHeight();
+        int keyboardWidth = this.keyboardLayout.getWidth();
+        int keyboardHeight = this.keyboardLayout.getHeight();
 
-        int _x = ((width - keyboardWidth) / 2) - HORIZONTAL_BUFFER;
-        int _y = height - keyboardHeight - 5 - 34;
+        int _x = ((this.width - keyboardWidth) / 2) - HORIZONTAL_BUFFER;
+        int _y = this.height - keyboardHeight - 5 - 34;
         return
             _x <= mx && mx < _x + (keyboardWidth + HORIZONTAL_BUFFER * 2) &&
-            _y <= my && my < _y + (keyboardHeight + 34 + 5);
+                _y <= my && my < _y + (keyboardHeight + 34 + 5);
     }
 
     @Override
     public void render(int mx, int my, float partialTick) {
-        if (parent != null) {
-            GL11.glPushMatrix();
-            GL11.glTranslatef(0, 0, -100);
-            parent.render(mx, my, partialTick);
-            GL11.glPopMatrix();
+        if (this.parent != null) {
+            GLRenderer.pushFrame();
+            GLRenderer.modelM4f().translate(0, 0, -100);
+            this.parent.render(mx, my, partialTick);
+            GLRenderer.popFrame();
         }
-        drawRect(0, 0, width, height, 0x90_00_00_00);
-        GL11.glColor4f(1f, 1f, 1f, 1f);
+        drawRect(0, 0, this.width, this.height, 0x90_00_00_00);
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
 
-        int keyboardWidth = keyboardLayout.getWidth();
-        int keyboardHeight = keyboardLayout.getHeight();
+        int keyboardWidth = this.keyboardLayout.getWidth();
+        int keyboardHeight = this.keyboardLayout.getHeight();
 
-        int _x = ((width - keyboardWidth) / 2);
-        int _y = height - keyboardHeight - 5;
+        int _x = ((this.width - keyboardWidth) / 2);
+        int _y = this.height - keyboardHeight - 5;
 
         drawGuiIcon(
             _x - 5 - HORIZONTAL_BUFFER,
@@ -227,19 +227,17 @@ public class ScreenKeyboard extends Screen implements ITextField {
             keyboardHeight + 8,
             TextureRegistry.getTexture("minecraft:gui/screen/keyboard/keyboard_background"));
 
-        Arrays.stream(keyboardLayout.getKeys()).forEach(key -> key.render(mc, this, _x, _y, mx, my));
+        Arrays.stream(this.keyboardLayout.getKeys()).forEach(key -> key.render(this.mc, this, _x, _y, mx, my));
 
-        drawStringCenteredShadow(mc.font, editor.getText(), _x + keyboardWidth/2, _y - 20, 0xFFFFFF);
+        drawStringCenteredShadow(this.mc.font, this.editor.getText(), _x + keyboardWidth / 2, _y - 20, 0xFFFFFF);
 
-        boolean drawCursor = (cursorCounter / 6) % 2 == 0;
-        if (drawCursor)
-        {
-            int width = MathHelper.ceil(fontRenderer.stringWidthDouble(editor.getText()));
-            if (editor.getCursor() < editor.getText().length())
-            {
-                width = MathHelper.ceil(fontRenderer.stringWidthDouble(editor.getText().substring(0, editor.getCursor())));
+        boolean drawCursor = (this.cursorCounter / 6) % 2 == 0;
+        if (drawCursor) {
+            int width = MathHelper.ceil(this.fontRenderer.stringWidthDouble(this.editor.getText()));
+            if (this.editor.getCursor() < this.editor.getText().length()) {
+                width = MathHelper.ceil(this.fontRenderer.stringWidthDouble(this.editor.getText().substring(0, this.editor.getCursor())));
             }
-            drawStringShadow(fontRenderer, "_", _x + keyboardWidth/2 - MathHelper.ceil(fontRenderer.stringWidthDouble(editor.getText())/2) + width, _y - 20 + 1, 0xE0E0E0);
+            drawStringShadow(this.fontRenderer, "_", _x + keyboardWidth / 2 - MathHelper.ceil(this.fontRenderer.stringWidthDouble(this.editor.getText()) / 2) + width, _y - 20 + 1, 0xE0E0E0);
         }
 
 
@@ -248,71 +246,71 @@ public class ScreenKeyboard extends Screen implements ITextField {
 
     @Override
     public void guiSpecificControllerInput(@NotNull ControllerInput controller) {
-        int keyboardWidth = keyboardLayout.getWidth();
-        int keyboardHeight = keyboardLayout.getHeight();
+        int keyboardWidth = this.keyboardLayout.getWidth();
+        int keyboardHeight = this.keyboardLayout.getHeight();
 
-        int _x = ((width - keyboardWidth) / 2);
-        int _y = height - keyboardHeight - 5;
+        int _x = ((this.width - keyboardWidth) / 2);
+        int _y = this.height - keyboardHeight - 5;
 
-        if(controller.buttonA.pressedThisFrame()) {
-            this.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 0);
+        if (controller.buttonA.pressedThisFrame()) {
+            this.mouseClicked((int) controller.cursorX, (int) controller.cursorY, 0);
         }
-        if(controller.buttonA.releasedThisFrame()) {
-            this.mouseReleased((int)controller.cursorX, (int)controller.cursorY, 0);
+        if (controller.buttonA.releasedThisFrame()) {
+            this.mouseReleased((int) controller.cursorX, (int) controller.cursorY, 0);
         }
 
         if (!controller.lockCursor) {
             if (controller.digitalPad.up.pressedThisFrame()) {
-                Key hovered = getHoveredKey((int)controller.cursorX, (int)controller.cursorY);
+                Key hovered = getHoveredKey((int) controller.cursorX, (int) controller.cursorY);
 
                 final int stepSize = 9;
-                int x = hovered != null ? (_x + hovered.getX() + hovered.getWidth()/2): MathHelper.clamp((int) controller.cursorX, keyboardLayout.getMinX() + _x, keyboardLayout.getMaxX() + _x);
-                int y = hovered != null ? (_y + hovered.getY() + hovered.getHeight()/2) : MathHelper.clamp((int) controller.cursorY, keyboardLayout.getMinY() + _y, keyboardLayout.getMaxY() + _y);
-                for (int i = 0; i < keyboardHeight/9; i++) {
+                int x = hovered != null ? (_x + hovered.getX() + hovered.getWidth() / 2) : MathHelper.clamp((int) controller.cursorX, this.keyboardLayout.getMinX() + _x, this.keyboardLayout.getMaxX() + _x);
+                int y = hovered != null ? (_y + hovered.getY() + hovered.getHeight() / 2) : MathHelper.clamp((int) controller.cursorY, this.keyboardLayout.getMinY() + _y, this.keyboardLayout.getMaxY() + _y);
+                for (int i = 0; i < keyboardHeight / 9; i++) {
                     int newY = y - stepSize * i;
                     while (newY < _y) {
                         newY += keyboardHeight;
                     }
-                    while (newY > height - 5) {
+                    while (newY > this.height - 5) {
                         newY -= keyboardHeight;
                     }
                     Key newHover = getHoveredKey(x, newY);
                     if (newHover != null && newHover != hovered) {
-                        controller.cursorX = _x + newHover.getX() + newHover.getWidth()/2f;
-                        controller.cursorY = _y + newHover.getY() + newHover.getHeight()/2f;
+                        controller.cursorX = _x + newHover.getX() + newHover.getWidth() / 2f;
+                        controller.cursorY = _y + newHover.getY() + newHover.getHeight() / 2f;
                         break;
                     }
                 }
             }
             if (controller.digitalPad.down.pressedThisFrame()) {
-                Key hovered = getHoveredKey((int)controller.cursorX, (int)controller.cursorY);
+                Key hovered = getHoveredKey((int) controller.cursorX, (int) controller.cursorY);
 
                 final int stepSize = 9;
-                int x = hovered != null ? (_x + hovered.getX() + hovered.getWidth()/2): MathHelper.clamp((int) controller.cursorX, keyboardLayout.getMinX() + _x, keyboardLayout.getMaxX() + _x);
-                int y = hovered != null ? (_y + hovered.getY() + hovered.getHeight()/2) : MathHelper.clamp((int) controller.cursorY, keyboardLayout.getMinY() + _y, keyboardLayout.getMaxY() + _y);
-                for (int i = 0; i < keyboardHeight/9; i++) {
+                int x = hovered != null ? (_x + hovered.getX() + hovered.getWidth() / 2) : MathHelper.clamp((int) controller.cursorX, this.keyboardLayout.getMinX() + _x, this.keyboardLayout.getMaxX() + _x);
+                int y = hovered != null ? (_y + hovered.getY() + hovered.getHeight() / 2) : MathHelper.clamp((int) controller.cursorY, this.keyboardLayout.getMinY() + _y, this.keyboardLayout.getMaxY() + _y);
+                for (int i = 0; i < keyboardHeight / 9; i++) {
                     int newY = y + stepSize * i;
                     while (newY < _y) {
                         newY += keyboardHeight;
                     }
-                    while (newY > height - 5) {
+                    while (newY > this.height - 5) {
                         newY -= keyboardHeight;
                     }
                     Key newHover = getHoveredKey(x, newY);
                     if (newHover != null && newHover != hovered) {
-                        controller.cursorX = _x + newHover.getX() + newHover.getWidth()/2f;
-                        controller.cursorY = _y + newHover.getY() + newHover.getHeight()/2f;
+                        controller.cursorX = _x + newHover.getX() + newHover.getWidth() / 2f;
+                        controller.cursorY = _y + newHover.getY() + newHover.getHeight() / 2f;
                         break;
                     }
                 }
             }
             if (controller.digitalPad.left.pressedThisFrame()) {
-                Key hovered = getHoveredKey((int)controller.cursorX, (int)controller.cursorY);
+                Key hovered = getHoveredKey((int) controller.cursorX, (int) controller.cursorY);
 
                 final int stepSize = 9;
-                int x = hovered != null ? (_x + hovered.getX() + hovered.getWidth()/2): MathHelper.clamp((int) controller.cursorX, keyboardLayout.getMinX() + _x, keyboardLayout.getMaxX() + _x);
-                int y = hovered != null ? (_y + hovered.getY() + hovered.getHeight()/2) : MathHelper.clamp((int) controller.cursorY, keyboardLayout.getMinY() + _y, keyboardLayout.getMaxY() + _y);
-                for (int i = 0; i < keyboardWidth/9; i++) {
+                int x = hovered != null ? (_x + hovered.getX() + hovered.getWidth() / 2) : MathHelper.clamp((int) controller.cursorX, this.keyboardLayout.getMinX() + _x, this.keyboardLayout.getMaxX() + _x);
+                int y = hovered != null ? (_y + hovered.getY() + hovered.getHeight() / 2) : MathHelper.clamp((int) controller.cursorY, this.keyboardLayout.getMinY() + _y, this.keyboardLayout.getMaxY() + _y);
+                for (int i = 0; i < keyboardWidth / 9; i++) {
                     int newX = x - stepSize * i;
                     while (newX < _x) {
                         newX += keyboardWidth;
@@ -322,19 +320,19 @@ public class ScreenKeyboard extends Screen implements ITextField {
                     }
                     Key newHover = getHoveredKey(newX, y);
                     if (newHover != null && newHover != hovered) {
-                        controller.cursorX = _x + newHover.getX() + newHover.getWidth()/2f;
-                        controller.cursorY = _y + newHover.getY() + newHover.getHeight()/2f;
+                        controller.cursorX = _x + newHover.getX() + newHover.getWidth() / 2f;
+                        controller.cursorY = _y + newHover.getY() + newHover.getHeight() / 2f;
                         break;
                     }
                 }
             }
             if (controller.digitalPad.right.pressedThisFrame()) {
-                Key hovered = getHoveredKey((int)controller.cursorX, (int)controller.cursorY);
+                Key hovered = getHoveredKey((int) controller.cursorX, (int) controller.cursorY);
 
                 final int stepSize = 9;
-                int x = hovered != null ? (_x + hovered.getX() + hovered.getWidth()/2): MathHelper.clamp((int) controller.cursorX, keyboardLayout.getMinX() + _x, keyboardLayout.getMaxX() + _x);
-                int y = hovered != null ? (_y + hovered.getY() + hovered.getHeight()/2) : MathHelper.clamp((int) controller.cursorY, keyboardLayout.getMinY() + _y, keyboardLayout.getMaxY() + _y);
-                for (int i = 0; i < keyboardWidth/9; i++) {
+                int x = hovered != null ? (_x + hovered.getX() + hovered.getWidth() / 2) : MathHelper.clamp((int) controller.cursorX, this.keyboardLayout.getMinX() + _x, this.keyboardLayout.getMaxX() + _x);
+                int y = hovered != null ? (_y + hovered.getY() + hovered.getHeight() / 2) : MathHelper.clamp((int) controller.cursorY, this.keyboardLayout.getMinY() + _y, this.keyboardLayout.getMaxY() + _y);
+                for (int i = 0; i < keyboardWidth / 9; i++) {
                     int newX = x + stepSize * i;
                     while (newX < _x) {
                         newX += keyboardWidth;
@@ -344,34 +342,34 @@ public class ScreenKeyboard extends Screen implements ITextField {
                     }
                     Key newHover = getHoveredKey(newX, y);
                     if (newHover != null && newHover != hovered) {
-                        controller.cursorX = _x + newHover.getX() + newHover.getWidth()/2f;
-                        controller.cursorY = _y + newHover.getY() + newHover.getHeight()/2f;
+                        controller.cursorX = _x + newHover.getX() + newHover.getWidth() / 2f;
+                        controller.cursorY = _y + newHover.getY() + newHover.getHeight() / 2f;
                         break;
                     }
                 }
             }
         }
 
-        Arrays.stream(keyboardLayout.getKeys()).forEach(key -> key.onButtonUse(mc, this, _x, _y));
+        Arrays.stream(this.keyboardLayout.getKeys()).forEach(key -> key.onButtonUse(this.mc, this, _x, _y));
     }
 
     @Override
     public void playControllerButtonSound(@NotNull ControllerInput controller) {
         if (controller.buttonStart.pressedThisFrame()) {
-            mc.sndManager.playSound("ui.ui_click", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
+            this.mc.sndManager.playSound("ui.ui_click", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
         }
         if (controller.buttonB.pressedThisFrame()) {
-            mc.sndManager.playSound("ui.ui_back", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
+            this.mc.sndManager.playSound("ui.ui_back", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
         }
     }
 
     public @Nullable Key getHoveredKey(int mx, int my) {
-        int keyboardWidth = keyboardLayout.getWidth();
-        int keyboardHeight = keyboardLayout.getHeight();
+        int keyboardWidth = this.keyboardLayout.getWidth();
+        int keyboardHeight = this.keyboardLayout.getHeight();
 
-        int _x = ((width - keyboardWidth) / 2);
-        int _y = height - keyboardHeight - 5;
-        for (Key key : keyboardLayout.getKeys()) {
+        int _x = ((this.width - keyboardWidth) / 2);
+        int _y = this.height - keyboardHeight - 5;
+        for (Key key : this.keyboardLayout.getKeys()) {
             if (key.isHovered(_x, _y, mx, my)) return key;
         }
         return null;
@@ -384,7 +382,7 @@ public class ScreenKeyboard extends Screen implements ITextField {
 
     @Override
     public String getText() {
-        return workingString;
+        return this.workingString;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/BackspaceKey.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/BackspaceKey.java
index 97163a2b3..b0212a963 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/BackspaceKey.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/BackspaceKey.java
@@ -78,16 +78,16 @@ public class BackspaceKey extends Key{
             if (src.height != DEFAULT_HEIGHT) object.addProperty("height", src.height);
             if (src.controllerButton != null) object.addProperty("button", src.controllerButton.name().toLowerCase(Locale.ROOT));
 
-            boolean ku = !src.keyUp.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_UP);
-            boolean kd = !src.keyDown.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_DOWN);
-            boolean kuh = !src.keyUpHovered.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_UP_HOVERED);
-            boolean kdh = !src.keyDownHovered.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_DOWN_HOVERED);
+            boolean ku = !src.keyUp.namespaceId.toString().equals(DEFAULT_TEXTURE_UP);
+            boolean kd = !src.keyDown.namespaceId.toString().equals(DEFAULT_TEXTURE_DOWN);
+            boolean kuh = !src.keyUpHovered.namespaceId.toString().equals(DEFAULT_TEXTURE_UP_HOVERED);
+            boolean kdh = !src.keyDownHovered.namespaceId.toString().equals(DEFAULT_TEXTURE_DOWN_HOVERED);
             if (ku || kd || kuh || kdh) {
                 JsonObject textureObject = new JsonObject();
-                if (ku) textureObject.addProperty("up", src.keyUp.sourceNamespaceId.toString());
-                if (kd) textureObject.addProperty("down", src.keyDown.sourceNamespaceId.toString());
-                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.sourceNamespaceId.toString());
-                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.sourceNamespaceId.toString());
+                if (ku) textureObject.addProperty("up", src.keyUp.namespaceId.toString());
+                if (kd) textureObject.addProperty("down", src.keyDown.namespaceId.toString());
+                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.namespaceId.toString());
+                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.namespaceId.toString());
                 object.add("textures", textureObject);
             }
 
